/////////////////////////////////////////////////////////////
//  PARTLIST.CPP
//
//  iXg쐬W[
//


#include "StdAfx.h"
#include "CE2TYPE.H"
#include "CE2DATA.H"	//C-pXJϊ֐Qgp

class CPListPart
{
public:
	CCe2Part*	m_pPart;
	CString		m_strName;
	CString		m_strPrefix;
	int			m_nSuffix;
};

static CPListPart**	s_ppPart;
static int			s_nPart;
static BOOL			s_bCsv,s_bSortName,s_bPreSuf,s_bPosition,s_bNoDuplicate;


///////////////////////////////////////////////////
// i|C^Zbg
static void s_SetPartPtr(CPtrList* pListPart)
{
	CCe2Part* pPart;
	CPListPart* pPListPart;

	char szName[64];
	char szPrefix[32];
	int	 nSuffix;

	POSITION pos=pListPart->GetHeadPosition();
	while(pos){
		pPart=(CCe2Part*)pListPart->GetNext(pos);
		if(pPart->refstr[0]==0 || pPart->valstr[0]==0) continue;
		pPListPart=new CPListPart;
		pPListPart->m_pPart=pPart;
		g_pstr2cstr(pPart->valstr,szName);
		pPListPart->m_strName=CString(szName);
		g_pstr2cstr(pPart->refstr,szPrefix);
		nSuffix=g_remove_tail_num(szPrefix);
		pPListPart->m_strPrefix=CString(szPrefix);
		pPListPart->m_nSuffix=nSuffix;
		s_ppPart[s_nPart]=pPListPart;
		s_nPart++;
	}
}

/////////////////////////////////////////////////////////////
//		p[c̔r
//
//s_bSortNameFALSÊƂ vtBbNXDBɃTtBbNXBɕiB
//s_bSortNameTRUE ̂Ƃ vtBbNXDBɕiBɃTtBbNXB
static int s_PartCmp(CPListPart** p1,CPListPart** p2)
{
	int n=lstrcmp((*p1)->m_strPrefix,(*p2)->m_strPrefix);
	if(n) return n;
	if(s_bSortName){
		n=lstrcmp((*p1)->m_strName,(*p2)->m_strName);
		if(n) return n;
		return((*p1)->m_nSuffix-(*p2)->m_nSuffix);
	}else{
		n=(*p1)->m_nSuffix-(*p2)->m_nSuffix;
		if(n) return n;
		return(lstrcmp((*p1)->m_strName,(*p2)->m_strName));
	}
}


/////////////////////////////////////////////////////////////
//		p[c̃\[g
static void s_SortPart(void)
{
	qsort(s_ppPart,s_nPart,sizeof(void*),
	(int(*)(const void *,const void *))s_PartCmp);
}

//////////////////////////////////////////////////////////////
//
static void s_MakeCsvWord(LPCSTR szSrc,char* szDest)
{
	while(*szSrc){
		if(*szSrc == '"') *szDest++='"';
		*szDest++=*szSrc++;
	}
	*szDest=0;
}



//////////////////////////////////////////////////////////////
//
static void s_MakeLine(char* pszBuff,CPListPart* pPListPart)
{
	char sz[32];
	char szNewName[64];
	char szNewPrefix[32];
	static char szOldName[64]="";
	static char szOldPrefix[32]="";
	static int  nOldSuffix=0;
	char cflag;

	
	if(    pPListPart->m_strPrefix==szOldPrefix
		&& pPListPart->m_nSuffix  ==nOldSuffix )
	{
		if(s_bNoDuplicate){*pszBuff=0; return;}
		else if(pPListPart->m_strName==szOldName) cflag='*';
		else								 cflag='?';
	}else{
											 cflag=' ';
	}
	lstrcpy(szOldName,pPListPart->m_strName);
	lstrcpy(szOldPrefix,pPListPart->m_strPrefix);
	nOldSuffix=pPListPart->m_nSuffix;

	if(s_bCsv){
		if(!s_bNoDuplicate){
			*pszBuff++='"';
			*pszBuff++=cflag;
			*pszBuff++='"';
			*pszBuff++=',';
		}
		s_MakeCsvWord(pPListPart->m_strName,szNewName);
		if(!s_bPreSuf){
			g_pstr2cstr(pPListPart->m_pPart->refstr,sz);
			s_MakeCsvWord(sz,szNewPrefix);
			wsprintf(pszBuff,
				"\"%s\",\"%s\"",szNewPrefix,szNewName);
		}else{
			s_MakeCsvWord(pPListPart->m_strPrefix,szNewPrefix);
			wsprintf(pszBuff,
				"\"%s\",%d,\"%s\"",szNewPrefix,nOldSuffix,szNewName);
		}
		if(s_bPosition){
			wsprintf(sz,",%d,%d",pPListPart->m_pPart->p.x,pPListPart->m_pPart->p.y);
			strcat(pszBuff,sz);
		}
	}else{
		g_pstr2cstr(pPListPart->m_pPart->refstr,sz);
		wsprintf(pszBuff,
			"%c %-8s    %-16s",cflag,sz,szOldName);
		if(s_bPosition){
			wsprintf(sz,"%5d %5d",pPListPart->m_pPart->p.x,pPListPart->m_pPart->p.y);
			strcat(pszBuff,sz);
		}
	}
}
	

	





BOOL g_PartList(CPtrList* pListPart,
				CStdioFile* pFileOut,
				CListBox* pListBox,
				BOOL bCsv,
				BOOL bSortName,
				BOOL bPreSuf,
				BOOL bPosition,
				BOOL bNoDuplicate)
{
	int n;
	
	char szBuff[256];
	
	const char* szHeader[]={
		"  Number      Name            ",
		"  Number      Name               X     Y",
	};

	n=pListPart->GetCount();
	if(n==0) return TRUE;
	//W[̃O[oϐ̏
	s_bCsv=bCsv;
	s_bSortName=bSortName;
	s_bPreSuf=bPreSuf;
	s_bPosition=bPosition;
	s_bNoDuplicate=bNoDuplicate;
	s_ppPart		=(CPListPart**)new BYTE[sizeof(CPListPart**)*n];
	s_nPart			=0;
	

	s_SetPartPtr(pListPart);	//ĩ|C^Zbg
	s_SortPart();				//\[g
	if(!s_bCsv){	//CSV[hłȂƂ̓wb_[t
		const char* psz;
		if(!s_bPosition)psz=szHeader[0];
		else			psz=szHeader[1];
		pListBox->AddString(psz);
		try{pFileOut->WriteString(psz);}
		catch(CFileException *e){if(e->m_cause!=CFileException::none) e->Delete();return FALSE;}
		try{pFileOut->WriteString("\n");}
		catch(CFileException *e){if(e->m_cause!=CFileException::none) e->Delete();return FALSE;}
	}

	for(n=0;n<s_nPart;n++){
		s_MakeLine(szBuff,s_ppPart[n]);
		if(szBuff[0]==0)continue;
		pListBox->AddString(szBuff);
		lstrcat(szBuff,"\n");
		try{pFileOut->WriteString(szBuff);}
		catch(CFileException *e){if(e->m_cause!=CFileException::none) e->Delete(); return FALSE;}
	}
	
	for(n=0;n<s_nPart;n++) delete s_ppPart[n];
	delete[]s_ppPart;
	return TRUE;
}

